    
(function(auth, $){
    // get token
    //console.log('implct grant stuff loading');
    //console.log('Current auth object value', auth);
    const clientId = "8ea4c456-2999-4d7e-89ba-43bb89e75431";

    function redirectToLogin() {
        var redirectUrl = window.location;
        var loginUrl = window.location.origin + '/SignIn?returnUrl=' + encodeURIComponent(redirectUrl);
        window.location = loginUrl;
    }

    function handleGetAuthenticationTokenSuccess(data, status, jqXHR) {
        var jsonResult = JSON.parse(jqXHR.getResponseHeader('X-Responded-JSON'));
        if (jsonResult && jsonResult.status == 401) {
            var forceLogin = Number($.cookie("ImplicitGrantForceLogin")) === 1;
            if (forceLogin) {
                // If the user is not logged in, redirect to login page
                redirectToLogin();
            } else {
                callback(null,jsonResult); //Run callback method with error message
            }
        } else {
            // Pass the token to the callback function
            callback(data);
        }
    }


    auth.getAuthenticationToken = function (callbackFn) {
        callback = callbackFn;
        $.ajax({
            type: 'POST',
            url: `/_services/auth/token?client_id=${clientId}`,
            cache: false,
            success: handleGetAuthenticationTokenSuccess,
            error: jqXHR => callback(null, jqXHR)
        });
    }

    auth.getAuthenticationTokenWithClientId = function (callbackFn) {
        callback = callbackFn;
        $.ajax({
            type: 'POST',
            url: `/_services/auth/token?client_id=${clientId}`,
            cache: false,
            success: handleGetAuthenticationTokenSuccess,
            error: jqXHR => callback(null, jqXHR)
        });
    }

    auth.getAuthenticationTokenPromise = function() {
        return new Promise((resolve, reject) => {
            auth.getAuthenticationTokenWithClientId(function(res) {
                if (res) {
                    resolve(res); 
                } else {
                    reject(new Error("Failed to get authentication token")); 
                }
            });
        });
    }

    //pass in payload
    auth.addAuthHeaderToPayload = function(payload){
        return new Promise((resolve, reject) => {
            auth.getAuthenticationTokenPromise()
            .then(token => {
                console.log("Authentication token:", token);
    
                (payload.headers ??= {}).Authorization ??= `Bearer ${token}`;
                resolve(payload) ;
            })
            .catch(error => {
                console.log(error)
                reject(error);
            });
        })
    }

    auth.fetchWithAuth = function(resource, options){
        return new Promise((resolve, reject) => {
            auth.getAuthenticationTokenPromise()
            .then(token => {
                console.log("Authentication token:", token);

                const headers = options.headers ?? {};

                const headersWithAuth = {
                    ...headers,
                    Authorization: `Bearer ${token}`
                };

                const optionsWithAuth = {
                    ...options,
                    headers: headersWithAuth
                };

                fetch(resource, optionsWithAuth).then((res) => resolve(res)).catch((err) => { console.log("FETCH ERROR",); reject(err); });
            })
            .catch(error => {
                console.log(error)
                reject(error);
            });
        })
    }

}(window.auth || (window.auth = {}), window.jQuery));